/**
   This program evaluates (interprets) an Abstract Syntax Tree (AST)
   that is defined by the following grammar.

        Exp ::= Begin | NExp

       NExp ::= Var | Set | AExp | BExp

      Begin ::= '(' 'begin' Exp  Exp+ ')'

        Var ::= '(' 'var' VARIABLE NExp ')'

        Set ::= '(' 'set' VARIABLE NExp ')'

       AExp ::= '(' BinOp NExp NExp ')'
              | '(' '+' NExp+ ')'
              | '(' '-' NExp ')'
              | '(' '-' NExp NExp ')'
              | '(' '*' NExp NExp+ ')'
              | INTEGER
              | VARIABLE

     BinOp  ::= '\' | ' %' | '^'

       BExp ::= '(' BoolOp NExp NExp+ ')'
              | '(' '!' NExp ')'
              | '(' RelOp  NExp NExp ')'
              | BOOLEAN
              | VARIABLE

     BoolOp ::= '&&' | '||'
     RelOp  ::= '<' | '>' | '<=' | '>=' | '==' | '!='

    INTEGER ::= [0-9]+
    BOOLEAN ::= 'true' | 'false'
   VARIABLE ::= [a-zA-Z][a-zA-Z0-9]*

   Notice that this language is a subset of the language of trees
   (i.e., cs50200-language-hw1).

   Notice that a Begin term can only be nested inside of another Begin term.
   In particular, you cannot nest a Begin inside of a Var or Set term.

   Notice that you can nest a Var or a Set term inside of an arithmetic
   or boolean exppression

   Notice that the '+' operator can take any number of inputs (i.e., one or more).
   Notice that the '-' operator can take one or two inputs.
   Notice that the '*', '&&', and '||' operators can take two or more inputs.

   The boolean '&&' and '||' operators should be short circuited.

   See the file cs50200-language-hw3.txt for more details on the semantics of this language.
*/

public class Evaluate
{
   public static Value evaluate(Tree tree) throws EvalException
   {
      Value result = null;


      // implement this method


      return  result;
   }




}//Evaluate