/*
  This program tests your implentations of Evaluate.java,
  and AST2infix.java. When your implentations are correct,
  the output from this program should look exactly like
  the contents of the file output.txt.

  You should consider creating your own test expressions to make
  sure your implementations are correct.
*/

public class Tests
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "( + 1 false )",   // runtime errors
         "( + true 2 )",
         "( && 1 false )",
         "( || false 0 )",
         "( ! ( + 1 1 ) )",
         "( + x 2 )",
         "( var x ( var x 2 ) )",
         "( set x 0 )",
         "( begin ( var x 0 ) ( && true x ) )",

         "( begin " +                   // test expressions
            "( var x1 1 ) " +
            "( set x1 ( + x1 2 ) ) " +
            "( begin " +
               "( set x1 ( + x1 2 ) ) " +
               "( var x1 ( + x1 2 ) ) " +
               "( set x1 ( + x1 2 ) ) " +
           " ) " +
            "( set x1 ( + x1 2 ) ) " +
            "( var x2 ( set x1 ( + x1 2 ) ) ) " +
        " )",

         "( begin " +
            "( var n 1 ) " +
            "( var x1 ( * n n ) ) " +
            "( set n 2 ) " +
            "( var x2 ( * n n ) ) " +
            "( set n 3 ) " +
            "( var x3 ( * n n ) ) " +
            "( set n 4 ) " +
            "( var x4 ( * n n ) ) " +
            "( + ( + ( + x1 x2 ) x3 ) x4 ) " +
        " )",

         "( begin " +
            "( var n 1 ) " +
            "( var x ( * n n ) ) " +
            "( set n 2 ) " +
            "( set x ( + x ( * n n ) ) ) " +
            "( set n 3 ) " +
            "( set x ( + x ( * n n ) ) ) " +
            "( set n 4 ) " +
            "( + x ( * n n ) ) " +
        " )"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         try
         {
            Tree ast = BuildTree.buildTree( exprs[i] );

            System.out.println( PrettyPrinter.prettyPrint( ast ) + "\n" );
            System.out.println( AST2infix.ast2infix( ast ) + "\n" );

            Value value = Evaluate.evaluate( ast );
            System.out.println( "result = " + value );
         }
         catch (EvalException e)
         {
            System.out.println(e);
         }
         System.out.println("=============================================");
      }
   }//main

}//Tests
