/**
   This clas is a kind of "tagged union". Each instance of this class holds
   a value for our simple language. But our language has two kinds of values,
   ints and booleans. So each instance of this class holds either an int value
   or a boolean value. The "tag" field is used to determin if an instance holds
   an int or a boolean.

   See also
      http://en.wikipedia.org/wiki/Tagged_union
*/

public class Value
{
   public String tag;    // either "int" or "bool"
   public int valueI=0;
   public boolean valueB=false;

   /**
      Construct a Value object that holds an int value.
   */
   public Value(String tag, int value)
   {
      if (tag.equals("int"))
      {
         this.tag = tag;
         valueI = value;
      }
      else
         throw new Error("invalid value tag: " + tag);
   }

   /**
      Construct a Value object that holds a boolean value.
   */
   public Value(String tag, boolean value)
   {
      if (tag.equals("bool"))
      {
         this.tag = tag;
         valueB = value;
      }
      else
         throw new Error("invalid value tag: " + tag);
   }

   public String toString()
   {
      return "[tag->" + tag + ", valueI->" + valueI + ", valueB->" + valueB + "]";
   }

/*
   public String toString()
   {
      String result = "";

      if ( tag.equals("bool") )
      {
         result += valueB;
      }
      else if ( tag.equals("int") )
      {
         result += valueI;
      }
      else  // bad tag (shouldn't get here)
      {
         result += "[tag->" + tag + ", valueI->" + valueI + ", valueB->" + valueB + "]";
      }

      return result;
   }
*/
}//Value